using System.Threading;
using NUnit.Framework;

namespace ebcbauteile.tests
{
    [TestFixture]
    public class PeriodicDispenserTests
    {
        [Test]
        public void Event_wird_sofort_weitergeleitet() {
            var sut = new PeriodicDispenser<int>();
            var eventParameter = 0;
            sut.Out_Event += x => eventParameter = x;

            sut.In_Event(42);

            Assert.That(eventParameter, Is.EqualTo(42));
        }

        [Test]
        public void Event_wird_nach_Ablauf_des_Timers_erneut_ausgelst() {
            var sut = new PeriodicDispenser<int>(1);
            var count = 0;
            sut.Out_Event += _ => count++;

            sut.In_Event(0);
            Thread.Sleep(1500);

            Assert.That(count, Is.EqualTo(2));
        }
    }
}